use strict;
sub stem
  {
   my @parms = @_;
   foreach( @parms )
    {
        $_ = lc $_;

        # Step 0 - remove punctuation
        s/'s$//; s/^[^a-z]+//; s/[^a-z]+$//;
        next unless /^[a-z]+$/;

        # step1a_rules
        if( /[^s]s$/ ) { s/sses$/ss/ || s/ies$/i/ || s/s$// }

        # step1b_rules. The business with rule==106 is embedded in the
        # boolean expressions here.
        (/[aeiouy][^aeiouy].*eed$/ && s/eed$/ee/ ) ||
            ( s/([aeiou].*)ed$/$1/ || s/([aeiouy].*)ing$/$1/ ) &&
            ( # step1b1_rules
                s/at$/ate/ || s/bl$/ble/ || s/iz$/ize/ || s/bb$/b/ ||
                s/dd$/d/   || s/ff$/f/   || s/gg$/g/   || s/mm$/m/ ||
                s/nn$/n/   || s/pp$/p/   || s/rr$/r/   || s/tt$/t/ ||
                s/ww$/w/   || s/xx$/x/   ||
                # This is wordsize==1 && CVC...addanE...
                s/^[^aeiouy]+[aeiouy][^aeiouy]$/$&e/
            );
        # step1c_rules
        s/([aeiouy].*)y$/$1i/;

        # step2_rules

        if (    s/ational$/ate/ || s/tional$/tion/ || s/enci$/ence/     ||
                s/anci$/ance/   || s/izer$/ize/    || s/iser$/ise/      ||
                s/abli$/able/   || s/alli$/al/     || s/entli$/ent/     ||
                s/eli$/e/       || s/ousli$/ous/   || s/ization$/ize/   ||
                s/isation$/ise/ || s/ation$/ate/   || s/ator$/ate/      ||
                s/alism$/al/    || s/iveness$/ive/ || s/fulnes$/ful/    ||
                s/ousness$/ous/ || s/aliti$/al/    || s/iviti$/ive/     ||
                s/biliti$/ble/
            ) {
            my ($l,$m) = ($`,$&);
            $_ = $l.$m unless $l =~ /[^aeiou][aeiouy]/;
        }
        # step3_rules
        if (    s/icate$/ic/    || s/ative$//   || s/alize$/al/ ||
                s/iciti$/ic/    || s/ical$/ic/  || s/ful$//     ||
                s/ness$//
            ) {
            my ($l,$m) = ($`,$&);
            $_ = $l.$m unless $l =~ /[^aeiou][aeiouy]/;
        }

        # step4_rules
        if (    s/al$//    || s/ance$// || s/ence$//    || s/er$//      ||
                s/ic$//    || s/able$// || s/ible$//    || s/ant$//     ||
                s/ement$// || s/ment$// || s/ent$//     || s/sion$/s/   ||
                s/tion$/t/ || s/ou$//   || s/ism$//     || s/ate$//     ||
                s/iti$//   || s/ous$//  || s/ive$//     || s/ize$//     ||
                s/ise$//
            ) {
            my ($l,$m) = ($`,$&);
        # Look for two consonant/vowel transitions
        # NB simplified...
            $_ = $l.$m unless $l =~ /[^aeiou][aeiouy].*[^aeiou][aeiouy]/;
        }

        # step5a_rules
        s/e$// if ( /[^aeiou][aeiouy].*[^aeiou][aeiouy].*e$/ ||
          ( /[aeiou][^aeiouy].*e/ && ! /[^aeiou][aeiouy][^aeiouwxy]e$/) );

        # step5b_rules
        s/ll$/l/ if /[^aeiou][aeiouy].*[^aeiou][aeiouy].*ll$/;

        # Cosmetic step
        s/(.)i$/$1y/;
    }
    
    return \@parms;
 }
 open(FILE,"d:/example/stop01.txt") or die "cant open file";
 while(my $line=<FILE>)
 {
	 my @term=split("#",$line);
	 my $title=$term[1];
	 my $abstract=$term[2];
	 
	 my @wordtitle=split(" ",$title);
	 my @wordabstract=split(" ",$abstract);
	 
	 my $totaltitle=stem (@wordtitle);
     my $totalabstract=stem(@wordabstract);
     open (OUTPUT,">>d:/example/stem01.txt");
     print OUTPUT "$term[0]"."#"." @$totaltitle "."#"." @$totalabstract \n";

 }
 
 close OUTPUT;
 close FILE;